﻿Public Class Form1

    Dim SplitterClickPos As New Point(0, 0)
    Dim iSplitterDistance As Integer = 0
    Dim Mouse_Down As Boolean = False

    Private Sub SplitContainer1_Layout(sender As Object, e As System.Windows.Forms.LayoutEventArgs) Handles SplitContainer1.Layout
        If iSplitterDistance <> 0 And Mouse_Down = False Then SplitContainer1.SplitterDistance = iSplitterDistance
    End Sub

    Private Sub SplitContainer1_Paint(sender As Object, e As PaintEventArgs) Handles SplitContainer1.Paint

        Dim Linepen As New Pen(Color.DarkSlateGray, 2)
        Dim ShadowPen As New Pen(Color.LightGray, 2)
        Dim WorkPen As Pen = Linepen

        Dim s As SplitContainer = CType(sender, SplitContainer)
        s.SplitterWidth = 20
        Const Diameter As Integer = 8
        Const myDistance As Integer = 10
        Dim ArrowHeight As Integer = s.SplitterWidth \ 2 - 3
        Dim Y As Integer = s.SplitterDistance + s.SplitterWidth \ 2 + 1
        Dim rec As Rectangle = e.ClipRectangle

        'Debug.Print("Rectangle W= " & rec.Width & " / H =" & rec.Height)

        With e.Graphics
            For c As Integer = 0 To 1
                If c = 1 Then WorkPen = Linepen Else WorkPen = ShadowPen
                'Grundlinie
                .DrawLine(WorkPen, (myDistance) - 2 * c, Y - 2 * c, (rec.Width \ 2 - myDistance) - 2 * c, Y - 2 * c)
                .DrawLine(WorkPen, (rec.Width \ 2 + myDistance) - 2 * c, Y - 2 * c, (rec.Width - myDistance) - 2 * c, Y - 2 * c)

                'Kreis
                .DrawEllipse(WorkPen, (rec.Width - Diameter) \ 2 - 2 * c, Y - Diameter \ 2 - 2 * c, Diameter, Diameter)
            Next
        End With

        Linepen.Dispose()
        WorkPen.Dispose()
        ShadowPen.Dispose()

    End Sub

    Private Sub SplitContainer1_SizeChanged(sender As Object, e As System.EventArgs) Handles SplitContainer1.SizeChanged
        SplitContainer1.Refresh()
    End Sub

    Private Sub SplitContainer1_MouseDown(sender As Object, e As MouseEventArgs) Handles SplitContainer1.MouseDown
        SplitterClickPos.X = e.X
        SplitterClickPos.Y = e.Y
        Mouse_Down = True
    End Sub

    Private Sub SplitContainer1_MouseUp(sender As Object, e As MouseEventArgs) Handles SplitContainer1.MouseUp
        If SplitterClickPos.X = e.X Or SplitterClickPos.Y = e.Y Then ' Nix machen, wenn Mouse verschoben wurde
            Dim MidY As Integer = SplitContainer1.SplitterDistance + SplitContainer1.SplitterWidth \ 2
            If e.Y < MidY - 1 Then
                SplitContainer1.SplitterDistance = SplitContainer1.Panel1MinSize
            ElseIf e.Y > MidY + 1 Then
                SplitContainer1.SplitterDistance = SplitContainer1.Height - SplitContainer1.SplitterWidth - SplitContainer1.Panel2MinSize
            End If
            iSplitterDistance = SplitContainer1.SplitterDistance
        End If
        Mouse_Down = False
    End Sub

    Private Sub Form1_Load(sender As Object, e As System.EventArgs) Handles Me.Load
        Me.DoubleBuffered = True
    End Sub

    Private Sub SplitContainer1_SplitterMoved(sender As Object, e As System.Windows.Forms.SplitterEventArgs) Handles SplitContainer1.SplitterMoved
        SplitContainer1.Refresh()
    End Sub

    Private Sub SplitContainer1_LostFocus(sender As Object, e As System.EventArgs) Handles SplitContainer1.LostFocus
        SplitContainer1.Refresh()
    End Sub

    'Private Sub SplitContainer1_GotFocus(sender As Object, e As System.EventArgs) Handles SplitContainer1.GotFocus
    '    Me.Refresh()
    'End Sub

    'Private Sub SplitContainer1_Enter(sender As Object, e As System.EventArgs) Handles SplitContainer1.Enter
    '    Me.Refresh()
    'End Sub

    'Private Sub SplitContainer1_SplitterMoving(sender As Object, e As System.Windows.Forms.SplitterCancelEventArgs) Handles SplitContainer1.SplitterMoving
    '    If Mouse_Down Then
    '        iSplitterDistance = e.SplitX
    '    End If
    'End Sub

    'Private Sub SplitContainer1_MouseClick(sender As Object, e As System.Windows.Forms.MouseEventArgs) Handles SplitContainer1.MouseClick
    '    SplitContainer1.Refresh()
    'End Sub

    'Private Sub SplitContainer1_Move(sender As Object, e As System.EventArgs) Handles SplitContainer1.Move
    '    SplitContainer1.Refresh()
    'End Sub

End Class
